<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - File Representation</TITLE>
<link href="suif1_8.html" rel=Next>
<link href="suif1_6.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_6.html">previous</A>, <A HREF="suif1_8.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC7" HREF="suif1_toc.html#TOC7">Representation of Source Files</A></H1>

<P>
Each SUIF program has a single internal data structure, called a
<STRONG>file set</STRONG>, which contains the global symbol table and a list of the
files being compiled.  Many passes work on a single file at a time, in
which case the file set contains only one file and is not very useful.
Interprocedural passes, on the other hand, typically need to work on all
of the files at once.  By using the file set, these interprocedural
passes need not resort to combining all of the code into one big source
file.

</P>
<P>
A source file within a file set is represented by a <STRONG>file set
entry</STRONG>, which contains the symbol table for the file scope and the input
and output streams.  File sets provide the mechanism to allow multiple
files to be read and written by a SUIF pass.

</P>
<P>
The symbol tables in the file set and file set entries basically form a
table of contents for the entire program.  They contain entries for
every symbol and type that is declared outside of procedures.  The
procedures and everything within them can be accessed via the procedure
symbols in the global symbol tables.

</P>
<P>
The <TT>`fileset.h'</TT> and <TT>`fileset.cc'</TT> files contain the source code
for the file set and file set entries.

</P>

<UL>
<LI><A HREF="suif1_8.html#SEC8">File Set</A>: The top-level of the SUIF hierarchy.
<LI><A HREF="suif1_9.html#SEC9">File Set Entries</A>: Operations on individual source files.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_6.html">previous</A>, <A HREF="suif1_8.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
